Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 84905)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 84906)
@@ -1894,4 +1894,6 @@
     comUnattendedInstaller.SetMachine(comMachine);
     checkUnattendedInstallError(comUnattendedInstaller);
+    comUnattendedInstaller.SetUser(unattendedData.m_strUserName);
+    comUnattendedInstaller.SetPassword(unattendedData.m_strPassword);
     comUnattendedInstaller.Prepare();
     checkUnattendedInstallError(comUnattendedInstaller);
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp	(revision 84905)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp	(revision 84906)
@@ -514,4 +514,7 @@
 {
     m_unattendedInstallData = unattendedInstallData;
+    UIWizardNewVMPageBasicInstallSetup *pPage = qobject_cast<UIWizardNewVMPageBasicInstallSetup *>(page(PageInstallSetup));
+    if (pPage)
+        pPage->setDefaultUnattendedInstallData(unattendedInstallData);
 }
 
@@ -529,4 +532,12 @@
     if (!fieldValue.isNull() && fieldValue.isValid() && fieldValue.canConvert(QMetaType::Bool))
         m_unattendedInstallData.m_fStartHeadless = fieldValue.toBool();
+
+    fieldValue = field("userName");
+    if (!fieldValue.isNull() && fieldValue.isValid() && fieldValue.canConvert(QMetaType::QString))
+        m_unattendedInstallData.m_strUserName = fieldValue.toString();
+
+    fieldValue = field("password");
+    if (!fieldValue.isNull() && fieldValue.isValid() && fieldValue.canConvert(QMetaType::QString))
+        m_unattendedInstallData.m_strPassword = fieldValue.toString();
 
     m_unattendedInstallData.m_uMachineUid = createdMachineId();
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasicInstallSetup.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasicInstallSetup.cpp	(revision 84905)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasicInstallSetup.cpp	(revision 84906)
@@ -47,4 +47,32 @@
 }
 
+QString UIUserNamePasswordEditor::userName() const
+{
+    if (m_pUserNameField)
+        return m_pUserNameField->text();
+    return QString();
+}
+
+void UIUserNamePasswordEditor::setUserName(const QString &strUserName)
+{
+    if (m_pUserNameField)
+        return m_pUserNameField->setText(strUserName);
+}
+
+QString UIUserNamePasswordEditor::password() const
+{
+    if (m_pPasswordField)
+        return m_pPasswordField->text();
+    return QString();
+}
+
+void UIUserNamePasswordEditor::setPassword(const QString &strPassword)
+{
+    if (m_pPasswordField)
+        m_pPasswordField->setText(strPassword);
+    if (m_pPasswordRepeatField)
+        m_pPasswordRepeatField->setText(strPassword);
+}
+
 void UIUserNamePasswordEditor::retranslateUi()
 {
@@ -68,5 +96,5 @@
 }
 
-void UIUserNamePasswordEditor::addField(QLabel *&pLabel, QLineEdit *&pLineEdit, QGridLayout *pLayout, bool fIsPasswordField /* = false */)
+void UIUserNamePasswordEditor::addLineEdit(QLabel *&pLabel, QLineEdit *&pLineEdit, QGridLayout *pLayout, bool fIsPasswordField /* = false */)
 {
     static int iRow = 0;
@@ -97,7 +125,8 @@
     setLayout(pMainLayout);
 
-    addField(m_pUserNameFieldLabel, m_pUserNameField, pMainLayout);
-    addField(m_pPasswordFieldLabel, m_pPasswordField, pMainLayout, true);
-    addField(m_pPasswordRepeatFieldLabel, m_pPasswordRepeatField, pMainLayout, true);
+    addLineEdit(m_pUserNameFieldLabel, m_pUserNameField, pMainLayout);
+    addLineEdit(m_pPasswordFieldLabel, m_pPasswordField, pMainLayout, true);
+    addLineEdit(m_pPasswordRepeatFieldLabel, m_pPasswordRepeatField, pMainLayout, true);
+
     retranslateUi();
 }
@@ -107,4 +136,19 @@
 {
 }
+
+QString UIWizardNewVMPageInstallSetup::userName() const
+{
+    if (m_pUserNamePasswordEditor)
+        return m_pUserNamePasswordEditor->userName();
+    return QString();
+}
+
+QString UIWizardNewVMPageInstallSetup::password() const
+{
+    if (m_pUserNamePasswordEditor)
+        return m_pUserNamePasswordEditor->password();
+    return QString();
+}
+
 
 UIWizardNewVMPageBasicInstallSetup::UIWizardNewVMPageBasicInstallSetup()
@@ -126,7 +170,19 @@
     }
 
+
     /* Register fields: */
-    // registerField("baseMemory", this, "baseMemory");
-    // registerField("VCPUCount", this, "VCPUCount");
+    registerField("userName", this, "userName");
+    registerField("password", this, "password");
+}
+
+void UIWizardNewVMPageBasicInstallSetup::setDefaultUnattendedInstallData(const UIUnattendedInstallData &unattendedInstallData)
+{
+    /* Initialize the widget data: */
+
+    if (m_pUserNamePasswordEditor)
+    {
+        m_pUserNamePasswordEditor->setUserName(unattendedInstallData.m_strUserName);
+        m_pUserNamePasswordEditor->setPassword(unattendedInstallData.m_strPassword);
+    }
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasicInstallSetup.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasicInstallSetup.h	(revision 84905)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasicInstallSetup.h	(revision 84906)
@@ -35,4 +35,5 @@
 class QSpinBox;
 class QIRichTextLabel;
+struct UIUnattendedInstallData;
 
 class UIUserNamePasswordEditor : public QIWithRetranslateUI<QWidget>
@@ -45,4 +46,10 @@
     UIUserNamePasswordEditor(QWidget *pParent = 0);
 
+    QString userName() const;
+    void setUserName(const QString &strUserName);
+
+    QString password() const;
+    void setPassword(const QString &strPassword);
+
 protected:
 
@@ -52,5 +59,5 @@
 
     void prepare();
-    void addField(QLabel *&pLabel, QLineEdit *&pLineEdit, QGridLayout *pLayout, bool fIsPasswordField = false);
+    void addLineEdit(QLabel *&pLabel, QLineEdit *&pLineEdit, QGridLayout *pLayout, bool fIsPasswordField = false);
 
     QLineEdit *m_pUserNameField;
@@ -67,8 +74,13 @@
 class UIWizardNewVMPageInstallSetup : public UIWizardPageBase
 {
+public:
+
+    UIWizardNewVMPageInstallSetup();
+
+    QString userName() const;
+    QString password() const;
+
 protected:
 
-    /* Constructor: */
-    UIWizardNewVMPageInstallSetup();
 
 
@@ -81,4 +93,6 @@
 {
     Q_OBJECT;
+    Q_PROPERTY(QString userName READ userName);
+    Q_PROPERTY(QString password READ password);
 
 public:
@@ -86,4 +100,5 @@
     /* Constructor: */
     UIWizardNewVMPageBasicInstallSetup();
+    void setDefaultUnattendedInstallData(const UIUnattendedInstallData &unattendedInstallData);
 
 private slots: