Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 84970)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 84971)
@@ -617,4 +617,6 @@
         unattendedInstallData.m_strPassword = comUnattendedInstaller.GetPassword();
         unattendedInstallData.m_strHostname = comUnattendedInstaller.GetHostname();
+        unattendedInstallData.m_fInstallGuestAdditions = comUnattendedInstaller.GetInstallGuestAdditions();
+        unattendedInstallData.m_strGuestAdditionsISOPath = comUnattendedInstaller.GetAdditionsIsoPath();
 
         pWizard->setDefaultUnattendedInstallData(unattendedInstallData);
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp	(revision 84970)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp	(revision 84971)
@@ -507,8 +507,7 @@
 void UIWizardNewVM::setDefaultUnattendedInstallData(const UIUnattendedInstallData &unattendedInstallData)
 {
-    m_unattendedInstallData = unattendedInstallData;
-    UIWizardNewVMPageBasicInstallSetup *pPage = qobject_cast<UIWizardNewVMPageBasicInstallSetup *>(page(PageInstallSetup));
-    if (pPage)
-        pPage->setDefaultUnattendedInstallData(unattendedInstallData);
+    setField("userName", unattendedInstallData.m_strUserName);
+    setField("password", unattendedInstallData.m_strPassword);
+    setField("hostname", unattendedInstallData.m_strHostname);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.h	(revision 84970)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.h	(revision 84971)
@@ -36,5 +36,4 @@
     QUuid m_uMachineUid;
     QString m_strISOPath;
-    QString m_strGAIOSPath;
     bool m_fStartHeadless;
     QString m_strUserName;
@@ -47,4 +46,6 @@
     QString m_strDetectedOSHints;
     QString m_strProductKey;
+    bool m_fInstallGuestAdditions;
+    QString m_strGuestAdditionsISOPath;
 };
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasicInstallSetup.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasicInstallSetup.cpp	(revision 84970)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasicInstallSetup.cpp	(revision 84971)
@@ -42,4 +42,10 @@
 }
 
+void UIWizardNewVMPageInstallSetup::setUserName(const QString &strName)
+{
+    if (m_pUserNamePasswordEditor)
+        return m_pUserNamePasswordEditor->setUserName(strName);
+}
+
 QString UIWizardNewVMPageInstallSetup::password() const
 {
@@ -49,4 +55,10 @@
 }
 
+void UIWizardNewVMPageInstallSetup::setPassword(const QString &strPassword)
+{
+    if (m_pUserNamePasswordEditor)
+        return m_pUserNamePasswordEditor->setPassword(strPassword);
+}
+
 QString UIWizardNewVMPageInstallSetup::hostname() const
 {
@@ -54,4 +66,10 @@
         return m_pHostnameLineEdit->text();
     return QString();
+}
+
+void UIWizardNewVMPageInstallSetup::setHostname(const QString &strHostName)
+{
+    if (m_pHostnameLineEdit)
+        return m_pHostnameLineEdit->setText(strHostName);
 }
 
@@ -84,16 +102,4 @@
     registerField("password", this, "password");
     registerField("hostname", this, "hostname");
-}
-
-void UIWizardNewVMPageBasicInstallSetup::setDefaultUnattendedInstallData(const UIUnattendedInstallData &unattendedInstallData)
-{
-    /* Initialize the widget data: */
-    if (m_pUserNamePasswordEditor)
-    {
-        m_pUserNamePasswordEditor->setUserName(unattendedInstallData.m_strUserName);
-        m_pUserNamePasswordEditor->setPassword(unattendedInstallData.m_strPassword);
-    }
-    if (m_pHostnameLineEdit)
-        m_pHostnameLineEdit->setText(unattendedInstallData.m_strHostname);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasicInstallSetup.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasicInstallSetup.h	(revision 84970)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasicInstallSetup.h	(revision 84971)
@@ -41,9 +41,12 @@
     UIWizardNewVMPageInstallSetup();
 
-    /** @name Property getters
+    /** @name Property getters/setters
       * @{ */
         QString userName() const;
+        void setUserName(const QString &strName);
         QString password() const;
+        void setPassword(const QString &strPassword);
         QString hostname() const;
+        void setHostname(const QString &strHostName);
     /** @} */
 
@@ -59,7 +62,7 @@
 {
     Q_OBJECT;
-    Q_PROPERTY(QString userName READ userName);
-    Q_PROPERTY(QString password READ password);
-    Q_PROPERTY(QString hostname READ hostname);
+    Q_PROPERTY(QString userName READ userName WRITE setUserName);
+    Q_PROPERTY(QString password READ password WRITE setPassword);
+    Q_PROPERTY(QString hostname READ hostname WRITE setHostname);
 
 public:
@@ -67,5 +70,4 @@
     /* Constructor: */
     UIWizardNewVMPageBasicInstallSetup();
-    void setDefaultUnattendedInstallData(const UIUnattendedInstallData &unattendedInstallData);
     virtual int nextId() const /* override */;
 