Index: trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibDragAndDrop.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibDragAndDrop.cpp	(revision 84984)
+++ trunk/src/VBox/Additions/common/VBoxGuest/lib/VBoxGuestR3LibDragAndDrop.cpp	(revision 84985)
@@ -73,5 +73,4 @@
 
     HGCMMsgGetNext Msg;
-    RT_ZERO(Msg);
     VBGL_HGCM_HDR_INIT(&Msg.hdr, pCtx->uClientID, GUEST_DND_GET_NEXT_HOST_MSG, 3);
     Msg.uMsg.SetUInt32(0);
@@ -128,6 +127,4 @@
 
     HGCMMsgHGAction Msg;
-    RT_ZERO(Msg);
-
     VBGL_HGCM_HDR_INIT(&Msg.hdr, pCtx->uClientID, uMsg, 8);
     Msg.u.v3.uContext.SetUInt32(0);
@@ -185,6 +182,4 @@
 
     HGCMMsgHGLeave Msg;
-    RT_ZERO(Msg);
-
     VBGL_HGCM_HDR_INIT(&Msg.hdr, pCtx->uClientID, HOST_DND_HG_EVT_LEAVE, 1);
     /** @todo Context ID not used yet. */
@@ -206,6 +201,4 @@
 
     HGCMMsgHGCancel Msg;
-    RT_ZERO(Msg);
-
     VBGL_HGCM_HDR_INIT(&Msg.hdr, pCtx->uClientID, HOST_DND_CANCEL, 1);
     /** @todo Context ID not used yet. */
@@ -239,6 +232,4 @@
 
     HGCMMsgHGSendDir Msg;
-    RT_ZERO(Msg);
-
     VBGL_HGCM_HDR_INIT(&Msg.hdr, pCtx->uClientID, HOST_DND_HG_SND_DIR, 4);
     /** @todo Context ID not used yet. */
@@ -282,6 +273,4 @@
 
     HGCMMsgHGSendFileData Msg;
-    RT_ZERO(Msg);
-
     VBGL_HGCM_HDR_INIT(&Msg.hdr, pCtx->uClientID, HOST_DND_HG_SND_FILE_DATA, 5);
     Msg.u.v3.uContext.SetUInt32(0);
@@ -330,6 +319,4 @@
 
     HGCMMsgHGSendFileHdr Msg;
-    RT_ZERO(Msg);
-
     VBGL_HGCM_HDR_INIT(&Msg.hdr, pCtx->uClientID, HOST_DND_HG_SND_FILE_HDR, 6);
     Msg.uContext.SetUInt32(0); /** @todo Not used yet. */
@@ -658,6 +645,4 @@
 
     HGCMMsgHGSendData Msg;
-    RT_ZERO(Msg);
-
     VBGL_HGCM_HDR_INIT(&Msg.hdr, pCtx->uClientID, HOST_DND_HG_SND_DATA, 5);
     Msg.u.v3.uContext.SetUInt32(0);
@@ -704,5 +689,4 @@
 
     HGCMMsgHGSendDataHdr Msg;
-    RT_ZERO(Msg);
     VBGL_HGCM_HDR_INIT(&Msg.hdr, pCtx->uClientID, HOST_DND_HG_SND_DATA_HDR, 12);
     Msg.uContext.SetUInt32(0);
@@ -971,6 +955,4 @@
 
     HGCMMsgGHReqPending Msg;
-    RT_ZERO(Msg);
-
     VBGL_HGCM_HDR_INIT(&Msg.hdr, pCtx->uClientID, HOST_DND_GH_REQ_PENDING, 2);
     /** @todo Context ID not used yet. */
@@ -1014,6 +996,4 @@
 
     HGCMMsgGHDropped Msg;
-    RT_ZERO(Msg);
-
     VBGL_HGCM_HDR_INIT(&Msg.hdr, pCtx->uClientID, HOST_DND_GH_EVT_DROPPED, 4);
     Msg.u.v3.uContext.SetUInt32(0);
@@ -1112,6 +1092,4 @@
          */
         HGCMMsgConnect Msg;
-        RT_ZERO(Msg);
-
         VBGL_HGCM_HDR_INIT(&Msg.hdr, pCtx->uClientID, GUEST_DND_CONNECT, 3);
         /** @todo Context ID not used yet. */
@@ -1367,6 +1345,4 @@
 
     HGCMMsgHGAck Msg;
-    RT_ZERO(Msg);
-
     VBGL_HGCM_HDR_INIT(&Msg.hdr, pCtx->uClientID, GUEST_DND_HG_ACK_OP, 2);
     /** @todo Context ID not used yet. */
@@ -1395,6 +1371,4 @@
 
     HGCMMsgHGReqData Msg;
-    RT_ZERO(Msg);
-
     VBGL_HGCM_HDR_INIT(&Msg.hdr, pCtx->uClientID, GUEST_DND_HG_REQ_DATA, 3);
     /** @todo Context ID not used yet. */
@@ -1422,6 +1396,4 @@
 
     HGCMMsgHGProgress Msg;
-    RT_ZERO(Msg);
-
     VBGL_HGCM_HDR_INIT(&Msg.hdr, pCtx->uClientID, GUEST_DND_HG_EVT_PROGRESS, 4);
     /** @todo Context ID not used yet. */
@@ -1459,6 +1431,4 @@
 
     HGCMMsgGHAckPending Msg;
-    RT_ZERO(Msg);
-
     VBGL_HGCM_HDR_INIT(&Msg.hdr, pCtx->uClientID, GUEST_DND_GH_ACK_PENDING, 5);
     /** @todo Context ID not used yet. */
@@ -1491,6 +1461,4 @@
 
     HGCMMsgGHSendDataHdr MsgHdr;
-    RT_ZERO(MsgHdr);
-
     VBGL_HGCM_HDR_INIT(&MsgHdr.hdr, pCtx->uClientID, GUEST_DND_GH_SND_DATA_HDR, 12);
     MsgHdr.uContext.SetUInt32(0);                           /** @todo Not used yet. */
@@ -1576,6 +1544,4 @@
 
     HGCMMsgGHSendDir Msg;
-    RT_ZERO(Msg);
-
     VBGL_HGCM_HDR_INIT(&Msg.hdr, pCtx->uClientID, GUEST_DND_GH_SND_DIR, 4);
     /** @todo Context ID not used yet. */
@@ -1614,6 +1580,4 @@
 
     HGCMMsgGHSendFileHdr MsgHdr;
-    RT_ZERO(MsgHdr);
-
     VBGL_HGCM_HDR_INIT(&MsgHdr.hdr, pCtx->uClientID, GUEST_DND_GH_SND_FILE_HDR, 6);
     MsgHdr.uContext.SetUInt32(0);                                                    /* Context ID; unused at the moment. */
@@ -1634,6 +1598,4 @@
          */
         HGCMMsgGHSendFileData Msg;
-        RT_ZERO(Msg);
-
         VBGL_HGCM_HDR_INIT(&Msg.hdr, pCtx->uClientID, GUEST_DND_GH_SND_FILE_DATA, 5);
         Msg.u.v3.uContext.SetUInt32(0);
@@ -1869,6 +1831,4 @@
 
     HGCMMsgGHError Msg;
-    RT_ZERO(Msg);
-
     VBGL_HGCM_HDR_INIT(&Msg.hdr, pCtx->uClientID, GUEST_DND_GH_EVT_ERROR, 2);
     /** @todo Context ID not used yet. */