Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic2.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic2.cpp	(revision 85066)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic2.cpp	(revision 85067)
@@ -119,8 +119,8 @@
 }
 
-void UIWizardNewVMPage2::createUserNameHostNameWidgets()
+QWidget *UIWizardNewVMPage2::createUserNameHostNameWidgets()
 {
     if (!m_pToolBox)
-        return;
+        return 0;
     QWidget *pContainer = new QWidget;
     QGridLayout *pGridLayout = new QGridLayout(pContainer);
@@ -132,11 +132,11 @@
     pGridLayout->addWidget(m_pHostnameLabel, 3, 0, 1, 1, Qt::AlignRight);
     pGridLayout->addWidget(m_pHostnameLineEdit, 3, 1, 1, 3);
-    m_pToolBox->insertItem(ToolBoxItems_UserNameHostname, pContainer, UIIconPool::iconSet(":/cloud_profile_manager_16px.png"), QString());
-}
-
-void UIWizardNewVMPage2::createGAInstallWidgets()
+    return pContainer;
+}
+
+QWidget *UIWizardNewVMPage2::createGAInstallWidgets()
 {
     if (!m_pToolBox)
-        return;
+        return 0;
     QWidget *pContainer = new QWidget;
     QGridLayout *pContainerLayout = new QGridLayout(pContainer);
@@ -160,12 +160,11 @@
     pContainerLayout->addWidget(m_pISOPathLabel, 1, 1, 1, 1);
     pContainerLayout->addWidget(m_pISOFilePathSelector, 1, 2, 1, 4);
-
-    m_pToolBox->insertItem(ToolBoxItems_GAInstall, pContainer, UIIconPool::iconSet(":/cloud_profile_manager_16px.png"), QString());
-}
-
-void UIWizardNewVMPage2::createProductKeyWidgets()
+    return pContainer;
+}
+
+QWidget *UIWizardNewVMPage2::createProductKeyWidgets()
 {
     if (!m_pToolBox)
-        return;
+        return 0;
     QWidget *pContainer = new QWidget;
     QGridLayout *pGridLayout = new QGridLayout(pContainer);
@@ -176,5 +175,5 @@
     pGridLayout->addWidget(m_pProductKeyLabel, 0, 0, 1, 1, Qt::AlignRight);
     pGridLayout->addWidget(m_pProductKeyLineEdit, 0, 1, 1, 3);
-    m_pToolBox->insertItem(ToolBoxItems_ProductKey, pContainer, UIIconPool::iconSet(":/cloud_profile_manager_16px.png"), QString());
+    return pContainer;
 }
 
@@ -210,7 +209,10 @@
     }
 
-    createUserNameHostNameWidgets();
-    createGAInstallWidgets();
-    createProductKeyWidgets();
+    m_pToolBox->insertItem(ToolBoxItems_UserNameHostname, createUserNameHostNameWidgets(),
+                           UIIconPool::iconSet(":/cloud_profile_manager_16px.png"), QString());
+    m_pToolBox->insertItem(ToolBoxItems_GAInstall, createGAInstallWidgets(),
+                           UIIconPool::iconSet(":/cloud_profile_manager_16px.png"), QString());
+    m_pToolBox->insertItem(ToolBoxItems_ProductKey, createProductKeyWidgets(),
+                           UIIconPool::iconSet(":/cloud_profile_manager_16px.png"), QString());
 
     registerField("userName", this, "userName");
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic2.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic2.h	(revision 85066)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic2.h	(revision 85067)
@@ -67,7 +67,7 @@
     };
 
-    void createUserNameHostNameWidgets();
-    void createGAInstallWidgets();
-    void createProductKeyWidgets();
+    QWidget *createUserNameHostNameWidgets();
+    QWidget *createGAInstallWidgets();
+    QWidget *createProductKeyWidgets();
 
     bool checkGAISOFile() const;
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic3.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic3.cpp	(revision 85066)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic3.cpp	(revision 85067)
@@ -154,5 +154,5 @@
 }
 
-void UIWizardNewVMPage3::createDiskWidgets()
+QWidget *UIWizardNewVMPage3::createDiskWidgets()
 {
     QWidget *pDiskContainer = new QWidget;
@@ -181,10 +181,8 @@
     pDiskLayout->addWidget(m_pDiskSelector, 3, 1);
     pDiskLayout->addWidget(m_pVMMButton, 3, 2);
-
-    if (m_pToolBox)
-        m_pToolBox->insertItem(ToolBoxItems_Disk, pDiskContainer, UIIconPool::iconSet(":/cloud_profile_manager_16px.png"), QString());
-}
-
-void UIWizardNewVMPage3::createHardwareWidgets()
+    return pDiskContainer;
+}
+
+QWidget *UIWizardNewVMPage3::createHardwareWidgets()
 {
     QWidget *pHardwareContainer = new QWidget;
@@ -195,8 +193,5 @@
     pHardwareLayout->addWidget(m_pBaseMemoryEditor, 0, 0, 1, 4);
     pHardwareLayout->addWidget(m_pVirtualCPUEditor, 1, 0, 1, 4);
-
-    if (m_pToolBox)
-        m_pToolBox->insertItem(ToolBoxItems_Hardware, pHardwareContainer,
-                               UIIconPool::iconSet(":/cloud_profile_manager_16px.png"), QString());
+    return pHardwareContainer;
 }
 
@@ -204,7 +199,5 @@
 {
     prepare();
-    /* Register classes: */
     qRegisterMetaType<CMedium>();
-    /* Register fields: */
     registerField("virtualDisk", this, "virtualDisk");
     registerField("virtualDiskId", this, "virtualDiskId");
@@ -223,6 +216,9 @@
     pMainLayout->addWidget(m_pLabel);
     pMainLayout->addWidget(m_pToolBox);
-    createDiskWidgets();
-    createHardwareWidgets();
+
+    m_pToolBox->insertItem(ToolBoxItems_Disk, createDiskWidgets(),
+                           UIIconPool::iconSet(":/cloud_profile_manager_16px.png"), QString());
+    m_pToolBox->insertItem(ToolBoxItems_Hardware, createHardwareWidgets(),
+                           UIIconPool::iconSet(":/cloud_profile_manager_16px.png"), QString());
 
     pMainLayout->addStretch();
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic3.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic3.h	(revision 85066)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic3.h	(revision 85067)
@@ -62,25 +62,21 @@
     bool getWithNewVirtualDiskWizard();
 
-    /** Stuff for 'virtualDisk' field. */
-    CMedium virtualDisk() const { return m_virtualDisk; }
-    void setVirtualDisk(const CMedium &virtualDisk) { m_virtualDisk = virtualDisk; }
 
-    /** Stuff for 'virtualDiskId' field. */
-    QUuid virtualDiskId() const { return m_uVirtualDiskId; }
-    void setVirtualDiskId(const QUuid &uVirtualDiskId) { m_uVirtualDiskId = uVirtualDiskId; }
+    /** @name Property getters/setters
+     * @{ */
+       CMedium virtualDisk() const { return m_virtualDisk; }
+       void setVirtualDisk(const CMedium &virtualDisk) { m_virtualDisk = virtualDisk; }
+       QUuid virtualDiskId() const { return m_uVirtualDiskId; }
+       void setVirtualDiskId(const QUuid &uVirtualDiskId) { m_uVirtualDiskId = uVirtualDiskId; }
+       QString virtualDiskName() const { return m_strVirtualDiskName; }
+       void setVirtualDiskName(const QString &strVirtualDiskName) { m_strVirtualDiskName = strVirtualDiskName; }
+       QString virtualDiskLocation() const { return m_strVirtualDiskLocation; }
+       void setVirtualDiskLocation(const QString &strVirtualDiskLocation) { m_strVirtualDiskLocation = strVirtualDiskLocation; }
+       int baseMemory() const;
+       int VCPUCount() const;
+    /** @} */
 
-    /** Stuff for 'virtualDiskName' field. */
-    QString virtualDiskName() const { return m_strVirtualDiskName; }
-    void setVirtualDiskName(const QString &strVirtualDiskName) { m_strVirtualDiskName = strVirtualDiskName; }
-
-    /** Stuff for 'virtualDiskLocation' field. */
-    QString virtualDiskLocation() const { return m_strVirtualDiskLocation; }
-    void setVirtualDiskLocation(const QString &strVirtualDiskLocation) { m_strVirtualDiskLocation = strVirtualDiskLocation; }
-
-    int baseMemory() const;
-    int VCPUCount() const;
-
-    void createDiskWidgets();
-    void createHardwareWidgets();
+    QWidget *createDiskWidgets();
+    QWidget *createHardwareWidgets();
 
     /** Helpers. */
@@ -90,9 +86,11 @@
     bool m_fRecommendedNoDisk;
 
-    /** Variables. */
-    CMedium m_virtualDisk;
-    QUuid   m_uVirtualDiskId;
-    QString m_strVirtualDiskName;
-    QString m_strVirtualDiskLocation;
+    /** @name Variables
+     * @{ */
+       CMedium m_virtualDisk;
+       QUuid   m_uVirtualDiskId;
+       QString m_strVirtualDiskName;
+       QString m_strVirtualDiskLocation;
+    /** @} */
 
     /** @name Widgets