Index: trunk/include/VBox/VBoxGuestLib.h
===================================================================
--- trunk/include/VBox/VBoxGuestLib.h	(revision 85093)
+++ trunk/include/VBox/VBoxGuestLib.h	(revision 85099)
@@ -104,7 +104,7 @@
  * @param type      Return type.  */
 # ifdef RT_OS_DARWIN /** @todo probably apply to all, but don't want a forest fire on our hands right now. */
-#  define DECLR0VBGL(type) DECLHIDDEN(type) VBOXCALL
+#  define DECLR0VBGL(type) DECLHIDDEN(DECL_NOTHROW(type)) VBOXCALL
 # else
-#  define DECLR0VBGL(type) type VBOXCALL
+#  define DECLR0VBGL(type) DECL_NOTHROW(type) VBOXCALL
 # endif
 # define DECLVBGL(type) DECLR0VBGL(type)
@@ -544,5 +544,5 @@
  * @param   type    The return type of the function declaration.
  */
-# define VBGLR3DECL(type) DECLHIDDEN(type) VBOXCALL
+# define VBGLR3DECL(type) DECL_HIDDEN_NOTHROW(type) VBOXCALL
 
 /** @name General-purpose functions
Index: trunk/include/VBox/cdefs.h
===================================================================
--- trunk/include/VBox/cdefs.h	(revision 85093)
+++ trunk/include/VBox/cdefs.h	(revision 85099)
@@ -121,10 +121,10 @@
 #if defined(IN_DIS)
 # ifdef IN_DIS_STATIC
-#  define DISDECL(type)     DECLHIDDEN(type) VBOXCALL
-# else
-#  define DISDECL(type)     DECLEXPORT(type) VBOXCALL
-# endif
-#else
-# define DISDECL(type)      DECLIMPORT(type) VBOXCALL
+#  define DISDECL(type)     DECL_HIDDEN_NOTHROW(type) VBOXCALL
+# else
+#  define DISDECL(type)     DECL_EXPORT_NOTHROW(type) VBOXCALL
+# endif
+#else
+# define DISDECL(type)      DECL_IMPORT_NOTHROW(type) VBOXCALL
 #endif
 
@@ -142,7 +142,7 @@
  */
 #if defined(IN_DBG_R3) || defined(IN_DBG)
-# define DBGDECL(type)      DECLEXPORT(type) VBOXCALL
-#else
-# define DBGDECL(type)      DECLIMPORT(type) VBOXCALL
+# define DBGDECL(type)      DECL_EXPORT_NOTHROW(type) VBOXCALL
+#else
+# define DBGDECL(type)      DECL_IMPORT_NOTHROW(type) VBOXCALL
 #endif
 
@@ -158,7 +158,7 @@
  */
 #ifdef IN_INTNET_R3
-# define INTNETR3DECL(type) DECLEXPORT(type) VBOXCALL
-#else
-# define INTNETR3DECL(type) DECLIMPORT(type) VBOXCALL
+# define INTNETR3DECL(type) DECL_EXPORT_NOTHROW(type) VBOXCALL
+#else
+# define INTNETR3DECL(type) DECL_IMPORT_NOTHROW(type) VBOXCALL
 #endif
 
@@ -172,7 +172,7 @@
  */
 #ifdef IN_INTNET_R0
-# define INTNETR0DECL(type) DECLEXPORT(type) VBOXCALL
-#else
-# define INTNETR0DECL(type) DECLIMPORT(type) VBOXCALL
+# define INTNETR0DECL(type) DECL_EXPORT_NOTHROW(type) VBOXCALL
+#else
+# define INTNETR0DECL(type) DECL_IMPORT_NOTHROW(type) VBOXCALL
 #endif
 
@@ -188,7 +188,7 @@
  */
 #ifdef IN_PCIRAW_R3
-# define PCIRAWR3DECL(type) DECLEXPORT(type) VBOXCALL
-#else
-# define PCIRAWR3DECL(type) DECLIMPORT(type) VBOXCALL
+# define PCIRAWR3DECL(type) DECL_EXPORT_NOTHROW(type) VBOXCALL
+#else
+# define PCIRAWR3DECL(type) DECL_IMPORT_NOTHROW(type) VBOXCALL
 #endif
 
@@ -202,7 +202,7 @@
  */
 #ifdef IN_PCIRAW_R0
-# define PCIRAWR0DECL(type) DECLEXPORT(type) VBOXCALL
-#else
-# define PCIRAWR0DECL(type) DECLIMPORT(type) VBOXCALL
+# define PCIRAWR0DECL(type) DECL_EXPORT_NOTHROW(type) VBOXCALL
+#else
+# define PCIRAWR0DECL(type) DECL_IMPORT_NOTHROW(type) VBOXCALL
 #endif
 
@@ -218,7 +218,7 @@
  */
 #ifdef IN_REM_R3
-# define REMR3DECL(type)    DECLEXPORT(type) VBOXCALL
-#else
-# define REMR3DECL(type)    DECLIMPORT(type) VBOXCALL
+# define REMR3DECL(type)    DECL_EXPORT_NOTHROW(type) VBOXCALL
+#else
+# define REMR3DECL(type)    DECL_IMPORT_NOTHROW(type) VBOXCALL
 #endif
 
@@ -235,13 +235,13 @@
 #ifdef IN_SUP_R3
 # ifdef IN_SUP_STATIC
-#  define SUPR3DECL(type)   DECLHIDDEN(type) VBOXCALL
-# else
-#  define SUPR3DECL(type)   DECLEXPORT(type) VBOXCALL
+#  define SUPR3DECL(type)   DECL_HIDDEN_NOTHROW(type) VBOXCALL
+# else
+#  define SUPR3DECL(type)   DECL_EXPORT_NOTHROW(type) VBOXCALL
 # endif
 #else
 # ifdef IN_SUP_STATIC
-#  define SUPR3DECL(type)   DECLHIDDEN(type) VBOXCALL
-# else
-#  define SUPR3DECL(type)   DECLIMPORT(type) VBOXCALL
+#  define SUPR3DECL(type)   DECL_HIDDEN_NOTHROW(type) VBOXCALL
+# else
+#  define SUPR3DECL(type)   DECL_IMPORT_NOTHROW(type) VBOXCALL
 # endif
 #endif
@@ -261,13 +261,13 @@
 #ifdef IN_SUP_R0
 # ifdef IN_SUP_STATIC
-#  define SUPR0DECL(type)   DECLHIDDEN(type) VBOXCALL
-# else
-#  define SUPR0DECL(type)   DECLEXPORT(type) VBOXCALL
+#  define SUPR0DECL(type)   DECL_HIDDEN_NOTHROW(type) VBOXCALL
+# else
+#  define SUPR0DECL(type)   DECL_EXPORT_NOTHROW(type) VBOXCALL
 # endif
 #else
 # ifdef IN_SUP_STATIC
-#  define SUPR0DECL(type)   DECLHIDDEN(type) VBOXCALL
-# else
-#  define SUPR0DECL(type)   DECLIMPORT(type) VBOXCALL
+#  define SUPR0DECL(type)   DECL_HIDDEN_NOTHROW(type) VBOXCALL
+# else
+#  define SUPR0DECL(type)   DECL_IMPORT_NOTHROW(type) VBOXCALL
 # endif
 #endif
@@ -282,7 +282,7 @@
  */
 #ifdef IN_SUP_RC
-# define SUPRCDECL(type)    DECLEXPORT(type) VBOXCALL
-#else
-# define SUPRCDECL(type)    DECLIMPORT(type) VBOXCALL
+# define SUPRCDECL(type)    DECL_EXPORT_NOTHROW(type) VBOXCALL
+#else
+# define SUPRCDECL(type)    DECL_IMPORT_NOTHROW(type) VBOXCALL
 #endif
 
@@ -296,7 +296,7 @@
  */
 #if defined(IN_SUP_R0) || defined(IN_SUP_R3) || defined(IN_SUP_RC)
-# define SUPDECL(type)      DECLEXPORT(type) VBOXCALL
-#else
-# define SUPDECL(type)      DECLIMPORT(type) VBOXCALL
+# define SUPDECL(type)      DECL_EXPORT_NOTHROW(type) VBOXCALL
+#else
+# define SUPDECL(type)      DECL_IMPORT_NOTHROW(type) VBOXCALL
 #endif
 
@@ -313,7 +313,7 @@
 # define USBLIB_DECL(type)   type VBOXCALL
 #elif defined(IN_USBLIB)
-# define USBLIB_DECL(type)   DECLEXPORT(type) VBOXCALL
-#else
-# define USBLIB_DECL(type)   DECLIMPORT(type) VBOXCALL
+# define USBLIB_DECL(type)   DECL_EXPORT_NOTHROW(type) VBOXCALL
+#else
+# define USBLIB_DECL(type)   DECL_IMPORT_NOTHROW(type) VBOXCALL
 #endif
 
@@ -334,13 +334,13 @@
 #ifdef IN_VMM_R3
 # ifdef IN_VMM_STATIC
-#  define VMMR3DECL(type)           DECLHIDDEN(type) VBOXCALL
-# else
-#  define VMMR3DECL(type)           DECLEXPORT(type) VBOXCALL
+#  define VMMR3DECL(type)           DECL_HIDDEN_NOTHROW(type) VBOXCALL
+# else
+#  define VMMR3DECL(type)           DECL_EXPORT_NOTHROW(type) VBOXCALL
 # endif
 #elif defined(IN_RING3)
 # ifdef IN_VMM_STATIC
-#  define VMMR3DECL(type)           DECLHIDDEN(type) VBOXCALL
-# else
-#  define VMMR3DECL(type)           DECLIMPORT(type) VBOXCALL
+#  define VMMR3DECL(type)           DECL_HIDDEN_NOTHROW(type) VBOXCALL
+# else
+#  define VMMR3DECL(type)           DECL_IMPORT_NOTHROW(type) VBOXCALL
 # endif
 #else
@@ -357,7 +357,7 @@
  */
 #ifdef IN_VMM_R0
-# define VMMR0DECL(type)            DECLEXPORT(type) VBOXCALL
+# define VMMR0DECL(type)            DECL_EXPORT_NOTHROW(type) VBOXCALL
 #elif defined(IN_RING0)
-# define VMMR0DECL(type)            DECLIMPORT(type) VBOXCALL
+# define VMMR0DECL(type)            DECL_IMPORT_NOTHROW(type) VBOXCALL
 #else
 # define VMMR0DECL(type)            DECL_INVALID(type)
@@ -373,7 +373,7 @@
  */
 #ifdef IN_VMM_RC
-# define VMMRCDECL(type)            DECLEXPORT(type) VBOXCALL
+# define VMMRCDECL(type)            DECL_EXPORT_NOTHROW(type) VBOXCALL
 #elif defined(IN_RC)
-# define VMMRCDECL(type)            DECLIMPORT(type) VBOXCALL
+# define VMMRCDECL(type)            DECL_IMPORT_NOTHROW(type) VBOXCALL
 #else
 # define VMMRCDECL(type)            DECL_INVALID(type)
@@ -385,7 +385,7 @@
  */
 #if defined(IN_VMM_R0) || defined(IN_VMM_RC)
-# define VMMRZDECL(type)            DECLEXPORT(type) VBOXCALL
+# define VMMRZDECL(type)            DECL_EXPORT_NOTHROW(type) VBOXCALL
 #elif defined(IN_RING0) || defined(IN_RZ)
-# define VMMRZDECL(type)            DECLIMPORT(type) VBOXCALL
+# define VMMRZDECL(type)            DECL_IMPORT_NOTHROW(type) VBOXCALL
 #else
 # define VMMRZDECL(type)            DECL_INVALID(type)
@@ -397,9 +397,9 @@
  */
 #ifdef IN_VMM_STATIC
-# define VMMDECL(type)              DECLHIDDEN(type) VBOXCALL
+# define VMMDECL(type)              DECL_HIDDEN_NOTHROW(type) VBOXCALL
 #elif defined(IN_VMM_R3) || defined(IN_VMM_R0) || defined(IN_VMM_RC)
-# define VMMDECL(type)              DECLEXPORT(type) VBOXCALL
-#else
-# define VMMDECL(type)              DECLIMPORT(type) VBOXCALL
+# define VMMDECL(type)              DECL_EXPORT_NOTHROW(type) VBOXCALL
+#else
+# define VMMDECL(type)              DECL_IMPORT_NOTHROW(type) VBOXCALL
 #endif
 
@@ -409,5 +409,5 @@
  */
 #if defined(IN_VMM_R3) || defined(IN_VMM_R0) || defined(IN_VMM_RC)
-# define VMM_INT_DECL(type)         DECLHIDDEN(type) VBOXCALL
+# define VMM_INT_DECL(type)         DECL_HIDDEN_NOTHROW(type) VBOXCALL
 #else
 # define VMM_INT_DECL(type)         DECL_INVALID(type)
@@ -419,5 +419,5 @@
  */
 #ifdef IN_VMM_R3
-# define VMMR3_INT_DECL(type)       DECLHIDDEN(type) VBOXCALL
+# define VMMR3_INT_DECL(type)       DECL_HIDDEN_NOTHROW(type) VBOXCALL
 #else
 # define VMMR3_INT_DECL(type)       DECL_INVALID(type)
@@ -429,5 +429,5 @@
  */
 #ifdef IN_VMM_R0
-# define VMMR0_INT_DECL(type)       DECLHIDDEN(type) VBOXCALL
+# define VMMR0_INT_DECL(type)       DECL_HIDDEN_NOTHROW(type) VBOXCALL
 #else
 # define VMMR0_INT_DECL(type)       DECL_INVALID(type)
@@ -439,5 +439,5 @@
  */
 #ifdef IN_VMM_RC
-# define VMMRC_INT_DECL(type)       DECLHIDDEN(type) VBOXCALL
+# define VMMRC_INT_DECL(type)       DECL_HIDDEN_NOTHROW(type) VBOXCALL
 #else
 # define VMMRC_INT_DECL(type)       DECL_INVALID(type)
@@ -449,5 +449,5 @@
  */
 #if defined(IN_VMM_RC) || defined(IN_VMM_R0)
-# define VMMRZ_INT_DECL(type)       DECLHIDDEN(type) VBOXCALL
+# define VMMRZ_INT_DECL(type)       DECL_HIDDEN_NOTHROW(type) VBOXCALL
 #else
 # define VMMRZ_INT_DECL(type)       DECL_INVALID(type)
@@ -465,10 +465,10 @@
 #ifdef IN_VBOXDDU
 # ifdef IN_VBOXDDU_STATIC
-#  define VBOXDDU_DECL(type) type
-# else
-#  define VBOXDDU_DECL(type) DECLEXPORT(type) VBOXCALL
-# endif
-#else
-# define VBOXDDU_DECL(type) DECLIMPORT(type) VBOXCALL
+#  define VBOXDDU_DECL(type)        type
+# else
+#  define VBOXDDU_DECL(type)        DECL_EXPORT_NOTHROW(type) VBOXCALL
+# endif
+#else
+# define VBOXDDU_DECL(type)         DECL_IMPORT_NOTHROW(type) VBOXCALL
 #endif
 