Index: trunk/src/VBox/Frontends/VBoxAutostart/VBoxAutostart-win.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxAutostart/VBoxAutostart-win.cpp	(revision 85118)
+++ trunk/src/VBox/Frontends/VBoxAutostart/VBoxAutostart-win.cpp	(revision 85121)
@@ -726,5 +726,6 @@
  *                          Currently not used.
  */
-static DWORD WINAPI autostartSvcWinServiceCtrlHandlerEx(DWORD dwControl, DWORD dwEventType, LPVOID pvEventData, LPVOID pvContext)
+static DWORD WINAPI
+autostartSvcWinServiceCtrlHandlerEx(DWORD dwControl, DWORD dwEventType, LPVOID pvEventData, LPVOID pvContext) RT_NOTHROW_DEF
 {
     LogFlow(("autostartSvcWinServiceCtrlHandlerEx: dwControl=%#x dwEventType=%#x pvEventData=%p\n",
Index: trunk/src/VBox/Frontends/VBoxBalloonCtrl/VBoxWatchdog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxBalloonCtrl/VBoxWatchdog.cpp	(revision 85118)
+++ trunk/src/VBox/Frontends/VBoxBalloonCtrl/VBoxWatchdog.cpp	(revision 85121)
@@ -302,5 +302,5 @@
  * unnecessary here.
  */
-static void signalHandler(int iSignal)
+static void signalHandler(int iSignal) RT_NOTHROW_DEF
 {
     NOREF(iSignal);
@@ -707,7 +707,7 @@
          */
         signal(SIGINT,   signalHandler);
-    #ifdef SIGBREAK
+#ifdef SIGBREAK
         signal(SIGBREAK, signalHandler);
-    #endif
+#endif
 
         /*
Index: trunk/src/VBox/Frontends/VBoxBalloonCtrl/VBoxWatchdogInternal.h
===================================================================
--- trunk/src/VBox/Frontends/VBoxBalloonCtrl/VBoxWatchdogInternal.h	(revision 85118)
+++ trunk/src/VBox/Frontends/VBoxBalloonCtrl/VBoxWatchdogInternal.h	(revision 85121)
@@ -138,5 +138,5 @@
      * @returns VBox status code.
      */
-    DECLCALLBACKMEMBER(int, pfnPreInit)(void);
+    DECLCALLBACKMEMBER(int, pfnPreInit,(void));
 
     /**
@@ -149,5 +149,5 @@
      *                      remaining arguments passed in.
      */
-    DECLCALLBACKMEMBER(int, pfnOption)(int argc, char *argv[], int *piConsumed);
+    DECLCALLBACKMEMBER(int, pfnOption,(int argc, char *argv[], int *piConsumed));
 
     /**
@@ -155,5 +155,5 @@
      * @returns VBox status code.
      */
-    DECLCALLBACKMEMBER(int, pfnInit)(void);
+    DECLCALLBACKMEMBER(int, pfnInit,(void));
 
     /** Called from the watchdog's main function. Non-blocking.
@@ -161,10 +161,10 @@
      * @returns VBox status code.
      */
-    DECLCALLBACKMEMBER(int, pfnMain)(void);
+    DECLCALLBACKMEMBER(int, pfnMain,(void));
 
     /**
      * Stop the module.
      */
-    DECLCALLBACKMEMBER(int, pfnStop)(void);
+    DECLCALLBACKMEMBER(int, pfnStop,(void));
 
     /**
@@ -173,5 +173,5 @@
      * @remarks This may be called even if pfnInit hasn't been called!
      */
-    DECLCALLBACKMEMBER(void, pfnTerm)(void);
+    DECLCALLBACKMEMBER(void, pfnTerm,(void));
 
     /** @name  Callbacks.
@@ -183,23 +183,23 @@
      * @returns VBox status code.
      */
-    DECLCALLBACKMEMBER(int, pfnOnMachineRegistered)(const Bstr &strUuid);
-
-    /**
-     *
-     * @returns VBox status code.
-     */
-    DECLCALLBACKMEMBER(int, pfnOnMachineUnregistered)(const Bstr &strUuid);
-
-    /**
-     *
-     * @returns VBox status code.
-     */
-    DECLCALLBACKMEMBER(int, pfnOnMachineStateChanged)(const Bstr &strUuid, MachineState_T enmState);
-
-    /**
-     *
-     * @returns VBox status code.
-     */
-    DECLCALLBACKMEMBER(int, pfnOnServiceStateChanged)(bool fAvailable);
+    DECLCALLBACKMEMBER(int, pfnOnMachineRegistered,(const Bstr &strUuid));
+
+    /**
+     *
+     * @returns VBox status code.
+     */
+    DECLCALLBACKMEMBER(int, pfnOnMachineUnregistered,(const Bstr &strUuid));
+
+    /**
+     *
+     * @returns VBox status code.
+     */
+    DECLCALLBACKMEMBER(int, pfnOnMachineStateChanged,(const Bstr &strUuid, MachineState_T enmState));
+
+    /**
+     *
+     * @returns VBox status code.
+     */
+    DECLCALLBACKMEMBER(int, pfnOnServiceStateChanged,(bool fAvailable));
 
     /** @} */
Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManage.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManage.cpp	(revision 85118)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManage.cpp	(revision 85121)
@@ -188,5 +188,5 @@
  * unnecessary here.
  */
-static void showProgressSignalHandler(int iSignal)
+static void showProgressSignalHandler(int iSignal) RT_NOTHROW_DEF
 {
     NOREF(iSignal);
Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageGuestCtrl.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageGuestCtrl.cpp	(revision 85118)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageGuestCtrl.cpp	(revision 85121)
@@ -377,5 +377,5 @@
 
 #ifdef RT_OS_WINDOWS
-static BOOL WINAPI gctlSignalHandler(DWORD dwCtrlType)
+static BOOL WINAPI gctlSignalHandler(DWORD dwCtrlType) RT_NOTHROW_DEF
 {
     bool fEventHandled = FALSE;
@@ -405,5 +405,5 @@
  * unnecessary here.
  */
-static void gctlSignalHandler(int iSignal)
+static void gctlSignalHandler(int iSignal) RT_NOTHROW_DEF
 {
     NOREF(iSignal);
Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageMetrics.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageMetrics.cpp	(revision 85118)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageMetrics.cpp	(revision 85121)
@@ -365,5 +365,5 @@
  * @remarks This is called on a new thread.
  */
-static BOOL WINAPI ctrlHandler(DWORD dwCtrlType)
+static BOOL WINAPI ctrlHandler(DWORD dwCtrlType) RT_NOTHROW_DEF
 {
     switch (dwCtrlType)
Index: trunk/src/VBox/Frontends/VBoxSDL/VBoxSDL.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxSDL/VBoxSDL.cpp	(revision 85118)
+++ trunk/src/VBox/Frontends/VBoxSDL/VBoxSDL.cpp	(revision 85121)
@@ -168,7 +168,7 @@
 static void    HandleGuestCapsChanged(void);
 static int     HandleHostKey(const SDL_KeyboardEvent *pEv);
-static Uint32  StartupTimer(Uint32 interval, void *param);
-static Uint32  ResizeTimer(Uint32 interval, void *param);
-static Uint32  QuitTimer(Uint32 interval, void *param);
+static Uint32  StartupTimer(Uint32 interval, void *param) RT_NOTHROW_PROTO;
+static Uint32  ResizeTimer(Uint32 interval, void *param) RT_NOTHROW_PROTO;
+static Uint32  QuitTimer(Uint32 interval, void *param) RT_NOTHROW_PROTO;
 static int     WaitSDLEvent(SDL_Event *event);
 static void    SetFullscreen(bool enable);
@@ -5068,5 +5068,5 @@
  * Timer callback function for startup processing
  */
-static Uint32 StartupTimer(Uint32 interval, void *param)
+static Uint32 StartupTimer(Uint32 interval, void *param) RT_NOTHROW_DEF
 {
     RT_NOREF(param);
@@ -5084,5 +5084,5 @@
  * Timer callback function to check if resizing is finished
  */
-static Uint32 ResizeTimer(Uint32 interval, void *param)
+static Uint32 ResizeTimer(Uint32 interval, void *param) RT_NOTHROW_DEF
 {
     RT_NOREF(interval, param);
@@ -5100,5 +5100,5 @@
  * Timer callback function to check if an ACPI power button event was handled by the guest.
  */
-static Uint32 QuitTimer(Uint32 interval, void *param)
+static Uint32 QuitTimer(Uint32 interval, void *param) RT_NOTHROW_DEF
 {
     RT_NOREF(interval, param);
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDesktopWidgetWatchdog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDesktopWidgetWatchdog.cpp	(revision 85118)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDesktopWidgetWatchdog.cpp	(revision 85121)
@@ -77,5 +77,5 @@
 }
 
-static BOOL CALLBACK MonitorEnumProcF(HMONITOR hMonitor, HDC hdcMonitor, LPRECT lpClipRect, LPARAM dwData)
+static BOOL CALLBACK MonitorEnumProcF(HMONITOR hMonitor, HDC hdcMonitor, LPRECT lpClipRect, LPARAM dwData) RT_NOTHROW_DEF
 {
     /* These required for clipped screens only: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/platform/win/VBoxUtils-win.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/platform/win/VBoxUtils-win.cpp	(revision 85118)
+++ trunk/src/VBox/Frontends/VirtualBox/src/platform/win/VBoxUtils-win.cpp	(revision 85121)
@@ -24,10 +24,10 @@
 {
     /** Enumerates visible always-on-top (top-most) windows. */
-    BOOL CALLBACK EnumWindowsProc(HWND hWnd, LPARAM lParam);
+    BOOL CALLBACK EnumWindowsProc(HWND hWnd, LPARAM lParam) RT_NOTHROW_PROTO;
     /** Contains visible top-most-window rectangles. */
     QList<QRect> topMostRects;
 }
 
-BOOL CALLBACK NativeWindowSubsystem::EnumWindowsProc(HWND hWnd, LPARAM)
+BOOL CALLBACK NativeWindowSubsystem::EnumWindowsProc(HWND hWnd, LPARAM) RT_NOTHROW_DEF
 {
     /* Ignore NULL HWNDs: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIKeyboardHandler.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIKeyboardHandler.cpp	(revision 85118)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIKeyboardHandler.cpp	(revision 85121)
@@ -1298,5 +1298,5 @@
 
 /* static */
-LRESULT CALLBACK UIKeyboardHandler::winKeyboardProc(int nCode, WPARAM wParam, LPARAM lParam)
+LRESULT CALLBACK UIKeyboardHandler::winKeyboardProc(int nCode, WPARAM wParam, LPARAM lParam) RT_NOTHROW_DEF
 {
     /* All keyboard class events needs to be handled: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIKeyboardHandler.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIKeyboardHandler.h	(revision 85118)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIKeyboardHandler.h	(revision 85121)
@@ -157,5 +157,5 @@
 #elif defined(VBOX_WS_WIN)
     /** Win: Performs initial pre-processing of all the native keyboard events. */
-    static LRESULT CALLBACK winKeyboardProc(int nCode, WPARAM wParam, LPARAM lParam);
+    static LRESULT CALLBACK winKeyboardProc(int nCode, WPARAM wParam, LPARAM lParam) RT_NOTHROW_PROTO;
     /** Win: Performs initial pre-processing of all the native keyboard events. */
     bool winKeyboardEvent(UINT msg, const KBDLLHOOKSTRUCT &event);